CitizenAmIBlocking = {
    name = "CitizenAmIBlocking",
    CallbackManager = ZO_CallbackObject:New(),
    hideUi = false
}
local stamReg = 0
local magReg = 0
local oldBlock = false

--Am I actually Blocking?
---CitizenAddon.name .."AmIBlocking", 100
function CitizenAmIBlocking.Refresh()
    local blocking = false
    local running = IsShiftKeyDown() and IsPlayerMoving()
    local inCombat = IsUnitInCombat('player')

    if inCombat then
        stamReg = GetPlayerStat(STAT_STAMINA_REGEN_COMBAT, STAT_BONUS_OPTION_APPLY_BONUS)
        magReg = GetPlayerStat(STAT_MAGICKA_REGEN_COMBAT, STAT_BONUS_OPTION_APPLY_BONUS)
    else
        stamReg = GetPlayerStat(STAT_STAMINA_REGEN_IDLE, STAT_BONUS_OPTION_APPLY_BONUS)
        magReg = GetPlayerStat(STAT_MAGICKA_REGEN_IDLE, STAT_BONUS_OPTION_APPLY_BONUS)
    end

    if IsBlockActive() and not running and (stamReg==0 or magReg==0) then
        blocking = true
    end

    CitizenAIB:SetHidden(not CitizenAmIBlocking.hideUi and not blocking)
    if not CitizenAIB:IsHidden() then
        CitizenAIB:SetMovable(true)
    end

    if oldBlock ~= blocking then
        CitizenAmIBlocking.CallbackManager:FireCallbacks(CitizenAmIBlocking.name .."BLOCKING_STATE_CHANGE", blocking)
        oldBlock = blocking
    end
end

--Save UI new location
function CitizenAmIBlocking.saveUiPosition()
    CitizenAddon.amIBlocking.left = CitizenAIB:GetLeft()
    CitizenAddon.amIBlocking.top = CitizenAIB:GetTop()
end