CitizenNearbyMembers = {
    name = "CitizenNearbyMembers",
    lockUi = true,
}

--Refresh
---CitizenAddon.name .."NearbyMembers", 350
function CitizenNearbyMembers.Refresh()
    local n = 0

    local _, x1, y1, z1 = GetUnitWorldPosition('player')
    for i=1, GetGroupSize(), 1 do
        local tag = GetGroupUnitTagByIndex(i)

        if IsGroupMemberInSameLayerAsPlayer(tag) and (not IsUnitDead(tag)) then
            if CitizenAddon.nearbyMembers.DdOnly then
                if GetGroupMemberSelectedRole(tag) == LFG_ROLE_DPS then
                    local _, x2, y2, z2 = GetUnitWorldPosition(tag)
                    if (zo_sqrt((x1-x2)^2 + (y1-y2)^2 + (z1-z2)^2) / 100) <= CitizenAddon.nearbyMembers.range then
                        n = n + 1
                    end
                end
            else
                local _, x2, y2, z2 = GetUnitWorldPosition(tag)
                if (zo_sqrt((x1-x2)^2 + (y1-y2)^2 + (z1-z2)^2) / 100) <= CitizenAddon.nearbyMembers.range then
                    n = n + 1
                end
            end
        end
    end

    CitizenNM_Text:SetText(n)
end

--Save UI new location
function CitizenNearbyMembers.saveUiPosition()
    CitizenAddon.nearbyMembers.left = CitizenNM:GetLeft()
    CitizenAddon.nearbyMembers.top = CitizenNM:GetTop()
end