CitizenClock = {
    name = "CitizenClock",
}

--CitizenClock.name .."RealTimeClockOneMinTick", 60000
function CitizenClock.RefreshEveryMin()
    local t, s = ZO_FormatTime(GetSecondsSinceMidnight(), TIME_FORMAT_STYLE_CLOCK_TIME, TIME_FORMAT_PRECISION_TWELVE_HOUR, nil)
	CitizenRTC_Time:SetText(t)

    if (60-s) > 2 then
        EVENT_MANAGER:UnregisterForUpdate(CitizenClock.name .."RealTimeClockOneMinTick")
        EVENT_MANAGER:RegisterForUpdate(CitizenAddon.name .."RealTimeClock", 750, CitizenClock.Refresh)
    end
end

--CitizenAddon.name .."RealTimeClock", 750
function CitizenClock.Refresh()
    local t, s = ZO_FormatTime(GetSecondsSinceMidnight(), TIME_FORMAT_STYLE_CLOCK_TIME, TIME_FORMAT_PRECISION_TWELVE_HOUR, nil)
	CitizenRTC_Time:SetText(t)

    if s == 60 then
        EVENT_MANAGER:UnregisterForUpdate(CitizenAddon.name .."RealTimeClock")
        EVENT_MANAGER:RegisterForUpdate(CitizenClock.name .."RealTimeClockOneMinTick", 60000, CitizenClock.RefreshEveryMin)
    end
end

--Save UI new location
function CitizenClock.saveUiPosition()
    CitizenAddon.realTimeClock.left = CitizenRTC:GetLeft()
    CitizenAddon.realTimeClock.top = CitizenRTC:GetTop()
end