CitizenSWR = {
    name = "CitizenSWR",
}
local foreman = {
    FF = false,
    SF = false,
    FS = false,
    SS = false,

    bombs = {},
}

--Unregistor
local function Unregistor()
    CitizenCitizenNotifier.RemoveBanner()
    EVENT_MANAGER:UnregisterForEvent(CitizenSWR.name .."SoulBombTrace", EVENT_COMBAT_EVENT)
    EVENT_MANAGER:UnregisterForEvent(CitizenSWR.name .."SoulBombTraceExe", EVENT_COMBAT_EVENT)
end

--Foreman Bradiggan Soul Bomb Tracker
---CitizenSWR.name .."SoulBombTrace", EVENT_COMBAT_EVENT
    --COMBAT_RESULT, ACTION_RESULT_BEGIN
    --ABILITY_ID, 163756
---CitizenSWR.name .."SoulBombTraceExe", EVENT_COMBAT_EVENT
    --COMBAT_RESULT, ACTION_RESULT_EFFECT_GAINED
    --ABILITY_ID, 168314
local function SoulBomb(_, result, _, _, _, _, _, _, _, _, _, _, _, _, _, targetUnitId, abilityId, _)
    if result==ACTION_RESULT_BEGIN and abilityId==163756 then --bomb1
        local targetDisplayName = GetUnitDisplayName(CitizenAddon.group.unitIdToUnitTag[targetUnitId])

        if CitizenAddon.player.displayName == CitizenAddon.SWR.foreman.userPairs.FF then
            if targetDisplayName == CitizenAddon.SWR.foreman.userPairs.FF then
                CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SF, 3000)
                CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
            elseif targetDisplayName == CitizenAddon.SWR.foreman.userPairs.SF then
                CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SF)
                CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
            else
                CitizenNotifier.Alert("NOYB!")
            end
        elseif CitizenAddon.player.displayName == CitizenAddon.SWR.foreman.userPairs.SF then
            if targetDisplayName == CitizenAddon.SWR.foreman.userPairs.FF then
                CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FF, 3000)
                CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
            elseif targetDisplayName == CitizenAddon.SWR.foreman.userPairs.SF then
                CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FF, 3000)
                CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
            else
                CitizenNotifier.Alert("NOYB!")
            end
        elseif CitizenAddon.player.displayName == CitizenAddon.SWR.foreman.userPairs.FS then
            if targetDisplayName == CitizenAddon.SWR.foreman.userPairs.FS then
                CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SS, 3000)
                CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
            elseif targetDisplayName == CitizenAddon.SWR.foreman.userPairs.SS then
                CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SS, 3000)
                CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
            else
                CitizenNotifier.Alert("NOYB!")
            end
        elseif CitizenAddon.player.displayName == CitizenAddon.SWR.foreman.userPairs.SS then
            if targetDisplayName == CitizenAddon.SWR.foreman.userPairs.FS then
                CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FS, 3000)
                CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
            elseif targetDisplayName == CitizenAddon.SWR.foreman.userPairs.SS then
                CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FS, 3000)
                CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
            else
                CitizenNotifier.Alert("NOYB!")
            end
        else
            CitizenNotifier.Alert(targetDisplayName)
        end

    elseif result==ACTION_RESULT_EFFECT_GAINED and abilityId==168314 then --bomb2
        local targetDisplayName = GetUnitDisplayName(CitizenAddon.group.unitIdToUnitTag[targetUnitId])

        if targetDisplayName == CitizenAddon.SWR.foreman.userPairs.FS then
            foreman.FS = true
        elseif targetDisplayName == CitizenAddon.SWR.foreman.userPairs.SF then
            foreman.SF = true
        elseif targetDisplayName == CitizenAddon.SWR.foreman.userPairs.SS then
            foreman.SS = true
        elseif targetDisplayName == CitizenAddon.SWR.foreman.userPairs.FF then
            foreman.FF = true
        end

        table.insert(foreman.bombs, targetDisplayName)

        if #foreman.bombs > 1 then
            if CitizenAddon.player.displayName == CitizenAddon.SWR.foreman.userPairs.FF then
                if foreman.FS==true and foreman.SF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.FS==true and foreman.SS==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.FS==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SF==true and foreman.SS==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SF==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SS==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                else
                    CitizenNotifier.Alert(foreman.bombs[1] .." / ".. foreman.bombs[2], 3000)
                end
            elseif CitizenAddon.player.displayName == CitizenAddon.SWR.foreman.userPairs.SF then
                if foreman.FS==true and foreman.SF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.FS==true and foreman.SS==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.FS==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SF==true and foreman.SS==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SF==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SS==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                else
                    CitizenNotifier.Alert(foreman.bombs[1] .." / ".. foreman.bombs[2], 3000)
                end
            elseif CitizenAddon.player.displayName == CitizenAddon.SWR.foreman.userPairs.FS then
                if foreman.FS==true and foreman.SF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.FS==true and foreman.SS==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.FS==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SF==true and foreman.SS==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SF==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SS==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                else
                    CitizenNotifier.Alert(foreman.bombs[1] .. " / " .. foreman.bombs[2], 3000)
                end
            elseif CitizenAddon.player.displayName == CitizenAddon.SWR.foreman.userPairs.SS then
                if foreman.FS==true and foreman.SF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.FS==true and foreman.SS==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.FS==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SF==true and foreman.SS==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SF==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.SF, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.SF, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                elseif foreman.SS==true and foreman.FF==true then
                    CitizenNotifier.Alert("|c3399ffStackWith:|r ".. CitizenAddon.SWR.foreman.userPairs.FS, 3000)
                    CitizenNotifier.Icon(CitizenAddon.SWR.foreman.userPairs.FS, CitizenMarker.iconData[13], CitizenAddon.SWR.foreman.soulBombOsiIconSize, {0,1,1}, nil, nil, 6000)
                else
                    CitizenNotifier.Alert(foreman.bombs[1] .." / ".. foreman.bombs[2], 3000)
                end
            else
                CitizenNotifier.Alert(foreman.bombs[1] .." / ".. foreman.bombs[2], 3000)
            end
            foreman.FF = false
            foreman.SF = false
            foreman.FS = false
            foreman.SS = false
            foreman.bombs = {}
        end
    end
end

-- function CitizenSWR.ForemanSoulBombMatcher()
--     local dd = 0
--     local healer = 0
--     local tank = 0
--     local rolesFix = true
--     local role = 0
--     local tag = ""

--     for i=1, GetGroupSize(), 1 do
--         tag = GetGroupUnitTagByIndex(i)
--         if IsUnitPlayer(tag) then
--             role = GetGroupMemberSelectedRole(tag)
--             if role == 1 then
--                 dd = dd + 1
--             elseif role == 2 then
--                 tank = tank + 1
--             elseif role == 4 then
--                 healer = healer + 1
--             end
--         end
--     end

--     if dd~=2 and tank~=1 and healer~=1 then
--         CitizenNotifier.Alert("Foreman |c3399ffSoul bomb|r matcher is |c4cbb17Active|r", 5000)
--         CitizenNotifier.Alert("Roles are |cff0000not|r fixed", 5000)
--         CitizenNotifier.Alert("select soul bombs pairs manualy", 5000)
--         rolesFix = false
--     end

--     if rolesFix then
--         for i=1, GetGroupSize(), 1 do
--             tag = GetGroupUnitTagByIndex(i)
--             if IsUnitPlayer(tag) then
--                 role = GetGroupMemberSelectedRole(tag)
--                 if role == 1 then
--                     if CitizenAddon.SWR.foreman.userPairs.SF == "" then
--                         CitizenAddon.SWR.foreman.userPairs.SF = GetUnitDisplayName(tag)
--                     else
--                         CitizenAddon.SWR.foreman.userPairs.SS = GetUnitDisplayName(tag)
--                     end
--                 elseif role == 2 then
--                     CitizenAddon.SWR.foreman.userPairs.FF = GetUnitDisplayName(tag)
--                 elseif role == 4 then
--                     CitizenAddon.SWR.foreman.userPairs.FS = GetUnitDisplayName(tag)
--                 end
--             end
--         end
--     end
-- end

--Is player in combat with correct target
---CitizenAddon.name .."InCombatInSWR", EVENT_PLAYER_COMBAT_STATE
function CitizenSWR.CombatState(_, inCombat)
    if inCombat then
        if DoesUnitExist('boss1') then
            if GetUnitName('boss1') == "Foreman Bradiggan" then
                if CitizenAddon.SWR.foreman.soulBomb then
                    ForemanSoulBombMatcher()
                    EVENT_MANAGER:RegisterForEvent(CitizenSWR.name .."SoulBombTrace", EVENT_COMBAT_EVENT, SoulBomb)--FILTERS
                        EVENT_MANAGER:AddFilterForEvent(CitizenCR.name .."SoulBombTrace", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_BEGIN)
                        EVENT_MANAGER:AddFilterForEvent(CitizenCR.name .."SoulBombTrace", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 163756)
                    --
                    EVENT_MANAGER:RegisterForEvent(CitizenSWR.name .."SoulBombTraceExe", EVENT_COMBAT_EVENT, SoulBomb)--FILTERS
                        EVENT_MANAGER:AddFilterForEvent(CitizenCR.name .."SoulBombTraceExe", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_EFFECT_GAINED)
                        EVENT_MANAGER:AddFilterForEvent(CitizenCR.name .."SoulBombTraceExe", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 168314)
                    --
                end
            end
        end
    else
        Unregistor()
    end
end