CitizenCR = {
    name = "CitizenCR",
}

--Unregistor
local function Unregistor()
    CitizenNotifier.RemoveBanner()
    EVENT_MANAGER:UnregisterForEvent(CitizenCR.name .."SiroriaFlareOSI", EVENT_COMBAT_EVENT)
    EVENT_MANAGER:UnregisterForEvent(CitizenCR.name .."SiroriaFlareExeOSI", EVENT_COMBAT_EVENT)
end

--Siroria Flare OSI
---CitizenCR.name .."SiroriaFlareOSI", EVENT_COMBAT_EVENT
    --COMBAT_RESULT, ACTION_RESULT_BEGIN
    --ABILITY_ID, 103531
---CitizenCR.name .."SiroriaFlareExeOSI", EVENT_COMBAT_EVENT
    --COMBAT_RESULT, ACTION_RESULT_BEGIN
    --ABILITY_ID, 110431
local function SiroriaFlare(_, _, _, _, _, _, _, _, _, _, _, _, _, _, _, targetUnitId, _, _)
    local targetUnitTag = CitizenAddon.group.unitIdToUnitTag[targetUnitId]
    local targetUnitDisplayName = GetUnitDisplayName(targetUnitTag)
    CitizenNotifier.Icon(targetUnitDisplayName, CitizenMarker.iconData[13], CitizenAddon.CR.siroriaFlareOsiIconSize, {1,0.5,0}, nil, nil, 6000)
end

--Is player in combat with correct target
---CitizenAddon.name .."InCombatInCR", EVENT_PLAYER_COMBAT_STATE
function CitizenCR.CombatState(_, inCombat)
    if inCombat then
        if CitizenAddon.CR.siroriaFlareOsi then
            EVENT_MANAGER:RegisterForEvent(CitizenCR.name .."SiroriaFlareOSI", EVENT_COMBAT_EVENT, SiroriaFlare)--FILTERS
                EVENT_MANAGER:AddFilterForEvent(CitizenCR.name .."SiroriaFlareOSI", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_BEGIN)
                EVENT_MANAGER:AddFilterForEvent(CitizenCR.name .."SiroriaFlareOSI", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 103531)
            --
            EVENT_MANAGER:RegisterForEvent(CitizenCR.name .."SiroriaFlareExeOSI", EVENT_COMBAT_EVENT, SiroriaFlare)--FILTERS
                EVENT_MANAGER:AddFilterForEvent(CitizenCR.name .."SiroriaFlareExeOSI", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_BEGIN)
                EVENT_MANAGER:AddFilterForEvent(CitizenCR.name .."SiroriaFlareExeOSI", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 110431)
            --
        end
    else
        Unregistor()
    end
end