CitizenRG = {
    name = "CitizenRG",
}
local bahsei ={
    bleed = {}
}

--Unregistor
local function Unregistor()
    CitizenNotifier.RemoveBanner()
    EVENT_MANAGER:UnregisterForEvent(CitizenRG.name .."OaxPoisonOSI", EVENT_EFFECT_CHANGED)
    EVENT_MANAGER:UnregisterForEvent(CitizenRG.name .."BahseiDeathTouchOSI", EVENT_EFFECT_CHANGED)
    EVENT_MANAGER:UnregisterForEvent(CitizenRG.name .."BleedTrace", EVENT_COMBAT_EVENT)
    EVENT_MANAGER:UnregisterForUpdate(CitizenRG.name .."BleedCheck")
end

--Check time of Bleeds
---CitizenRG.name .."BleedCheck", 200
local function BleedChecker()
    local currentTime = GetGameTimeMilliseconds() / 1000
    local timer = bahsei.bleed[1] - currentTime

    if currentTime >= bahsei.bleed[1] then
        table.remove(bahsei.bleed, 1)
    end

    if CitizenAddon.RG.bahsei.offTankOnly then
        if #bahsei.bleed == 1 then
            CitizenNotifier.SetBanner("|c990000Bleed|r: ".. string.format("%.0f", timer) .."s")
        elseif #bahsei.bleed == 2 then
            CitizenNotifier.SetBanner("Double!|c990000Bleed|r: ".. string.format("%.0f", timer) .."s")
        elseif #bahsei.bleed == 3 then
            CitizenNotifier.SetBanner("|cd4af37Triple!!|r|c990000Bleed|r: ".. string.format("%.0f", timer) .."s")
        elseif #bahsei.bleed == 4 then
            CitizenNotifier.SetBanner("|c288ba8Quadruple!!!|r|c990000Bleed|r: ".. string.format("%.0f", timer) .."s")
        elseif #bahsei.bleed >= 5 then
            CitizenNotifier.SetBanner("U GUYS AFK OR WHAT?")
        else
            CitizenNotifier.RemoveBanner()
        end
    else
        if #bahsei.bleed == 1 then
            CitizenNotifier.SetBanner("|c990000Bleed|r: ".. string.format("%.0f", timer) .."s")
        elseif #bahsei.bleed == 2 then
            CitizenNotifier.SetBanner("|c990000Bleed|r: ".. string.format("%.0f", timer) .."s".." |c990000/|r ".. string.format("%.0f", bahsei.bleed[2] - currentTime) .."s")
        elseif #bahsei.bleed == 3 then
            CitizenNotifier.SetBanner("|c990000Bleed|r: ".. string.format("%.0f", timer) .."s".." |c990000/|r ".. string.format("%.0f", bahsei.bleed[2] - currentTime) .."s".." |c990000/|r ".. string.format("%.0f", bahsei.bleed[3] - currentTime) .."s")
        elseif #bahsei.bleed == 4 then
            CitizenNotifier.SetBanner("|c990000Bleed|r: ".. string.format("%.0f", timer) .."s".." |c990000/|r ".. string.format("%.0f", bahsei.bleed[2] - currentTime) .."s".." |c990000/|r ".. string.format("%.0f", bahsei.bleed[3] - currentTime) .."s".." |c990000/|r ".. string.format("%.0f", bahsei.bleed[4] - currentTime) .."s")
        elseif #bahsei.bleed >= 5 then
            CitizenNotifier.SetBanner("U GUYS AFK OR WHAT?")
        else
            CitizenNotifier.RemoveBanner()
        end
    end

    if timer <= 0 then
        CitizenNotifier.RemoveBanner()
    end
    if #bahsei.bleed == 0 then
        EVENT_MANAGER:UnregisterForUpdate(CitizenRG.name .."BleedCheck")
    end
end

--Track Abo Bleed Attack
---CitizenRG.name .."BleedTrace", EVENT_COMBAT_EVENT
    --COMBAT_RESULT, ACTION_RESULT_BEGIN
    --ABILITY_ID, 150008
local function BleedTracker(_, _, _, _, _, _, _, _, _, _, _, _, _, _, _, targetUnitId, _, _)
    local currentTime = GetGameTimeMilliseconds() / 1000

    local targetUnitDisplayName = GetUnitDisplayName(CitizenAddon.group.unitIdToUnitTag[targetUnitId])

    if CitizenAddon.RG.bahsei.bleedOsi then
        CitizenNotifier.Icon(targetUnitDisplayName, CitizenMarker.iconData[13], CitizenAddon.RG.bahsei.bleedOsiIconSize, {1,0,0}, nil, nil, 10000)
    end

    if CitizenAddon.RG.bahsei.offTankOnly then
        if CitizenAddon.RG.bahsei.offTankDisplayName == targetUnitDisplayName then
            table.insert(bahsei.bleed, currentTime+10)
            EVENT_MANAGER:RegisterForUpdate(CitizenRG.name .."BleedCheck", 200, BleedChecker)
        end
    elseif CitizenAddon.RG.bahsei.bleedTracker then
        table.insert(bahsei.bleed, currentTime+10)
        EVENT_MANAGER:RegisterForUpdate(CitizenRG.name .."BleedCheck", 200, BleedChecker)
    end
end

--Bahsei OSI death touch
---CitizenRG.name .."BahseiDeathTouchOSI", EVENT_EFFECT_CHANGED
    --UNIT_TAG_PREFIX, 'group'
    --ABILITY_ID, 150078
local function BahseiDeathTouch(_, changeType, _, _, unitTag, _, _, _, _, _, _, _, _, _, _, _, _)
    if changeType == EFFECT_RESULT_GAINED then
        CitizenNotifier.Icon(GetUnitDisplayName(unitTag), CitizenMarker.iconData[13], nil, {0,1,1}, nil, nil, 9000)
    elseif changeType == EFFECT_RESULT_FADED then
        CitizenNotifier.RemoveIcon(GetUnitDisplayName(unitTag))
    end
end

--Oax OSI poison
---CitizenRG.name .."OaxPoisonOSI", EVENT_EFFECT_CHANGED
    --UNIT_TAG_PREFIX, 'group'
    --ABILITY_ID, 157860
local function OaxPoison(_, changeType, _, _, unitTag, _, _, _, _, _, _, _, _, _, _, _, _)
    if changeType == EFFECT_RESULT_GAINED then
        CitizenNotifier.Icon(GetUnitDisplayName(unitTag), CitizenMarker.iconData[13], CitizenAddon.RG.oax.poisonOsiIconSize, {0,1,0}, nil, nil, nil)
    elseif changeType == EFFECT_RESULT_FADED then
        CitizenNotifier.RemoveIcon(GetUnitDisplayName(unitTag))
    end
end

--Find Off-tank automaticly
-- function CitizenRG.BahseiOffTankFinder()
--     local offTankFound = false
--     local role = 0
--     local tag = ""

--     for i=1, GetGroupSize(), 1 do
--         tag = GetGroupUnitTagByIndex(i)
--         if IsUnitPlayer(tag) then
--             role = GetGroupMemberSelectedRole(tag)
--             if role == 2 then
--                 if GetUnitClassId(tag)==5 or GetUnitClassId(tag)==117 then
--                     CitizenAddon.RG.bahsei.offTankDisplayName = GetUnitDisplayName(tag)
--                     offTankFound = true
--                 end
--             end
--         end
--     end

--     if CitizenAddon.RG.bahsei.bleedTracker==true and CitizenAddon.RG.bahsei.offTankOnly==true and offTankFound==false then
--         CitizenNotifier.Alert("Bahsei bleed tracker is |c4cbb17Active|r", 5000)
--         CitizenNotifier.Alert("Only off-tank is |c4cbb17Active|r", 5000)
--         CitizenNotifier.Alert("Off-tank |cff0000not|r found, select off-tank ID manually", 5000)
--     end
-- end

--Is player in combat with correct target
---CitizenAddon.name .."InCombatInRG", EVENT_PLAYER_COMBAT_STATE
function CitizenRG.CombatState(_, inCombat)
    if inCombat then
        if DoesUnitExist('boss1') then
            if GetUnitName('boss1') == "Oaxiltso" then
                if CitizenAddon.RG.oax.poisonOsi then
                    EVENT_MANAGER:RegisterForEvent(CitizenRG.name .."OaxPoisonOSI", EVENT_EFFECT_CHANGED, OaxPoison)--FILTERS
                        EVENT_MANAGER:AddFilterForEvent(CitizenRG.name .."OaxPoisonOSI", EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG_PREFIX, 'group')
                        EVENT_MANAGER:AddFilterForEvent(CitizenRG.name .."OaxPoisonOSI", EVENT_EFFECT_CHANGED, REGISTER_FILTER_ABILITY_ID, 157860)
                    --
                end
            elseif GetUnitName('boss1') == "Flame-Herald Bahsei" then
                if CitizenAddon.RG.bahsei.deathTouchOsi then
                    EVENT_MANAGER:RegisterForEvent(CitizenRG.name .."BahseiDeathTouchOSI", EVENT_EFFECT_CHANGED, BahseiDeathTouch)--FILTERS
                        EVENT_MANAGER:AddFilterForEvent(CitizenRG.name .."BahseiDeathTouchOSI", EVENT_EFFECT_CHANGED, REGISTER_FILTER_UNIT_TAG_PREFIX, 'group')
                        EVENT_MANAGER:AddFilterForEvent(CitizenRG.name .."BahseiDeathTouchOSI", EVENT_EFFECT_CHANGED, REGISTER_FILTER_ABILITY_ID, 150078)
                    --
                end
                if CitizenAddon.RG.bahsei.bleedTracker or CitizenAddon.RG.bahsei.bleedOsi then
                    EVENT_MANAGER:RegisterForEvent(CitizenRG.name .."BleedTrace", EVENT_COMBAT_EVENT, BleedTracker)--FILTERS
                        EVENT_MANAGER:AddFilterForEvent(CitizenRG.name .."BleedTrace", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_BEGIN)
                        EVENT_MANAGER:AddFilterForEvent(CitizenRG.name .."BleedTrace", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 150008)
                    --
                end
            end
        end
    else
        Unregistor()
    end
end