CitizenSE = {
    name = "CitizenSE",
}
local ansuul = {
    banishTime = 0,
}

--Unregistor
local function Unregistor()
    CitizenNotifier.RemoveAllBanners()
    EVENT_MANAGER:UnregisterForUpdate(CitizenSE.name .."AnsuulHp")
    EVENT_MANAGER:UnregisterForEvent(CitizenSE.name .."ExecuteBanish", EVENT_COMBAT_EVENT)
    EVENT_MANAGER:UnregisterForUpdate(CitizenSE.name .."ExecuteBanishTimer")
end

--Execute banish timer
---CitizenSE.name .."ExecuteBanishTimer", 1000
local function ExeBanishTimer()
    local timer = ansuul.banishTime - (GetGameTimeMilliseconds() / 1000)

    if timer > 0 then
        CitizenNotifier.SetBanner("|cb042ffBanish in|r: ".. string.format("%.0f", timer) .."s")
    else
        CitizenNotifier.RemoveBanner()
        EVENT_MANAGER:UnregisterForUpdate(CitizenSE.name .."ExecuteBanishTimer")
    end
end

--If boss casted Banish in execute
---CitizenSE.name .."ExecuteBanish", EVENT_COMBAT_EVENT
    --COMBAT_RESULT, ACTION_RESULT_BEGIN
    --ABILITY_ID, 185117
local function ExeBanish(_, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _)
    ansuul.banishTime = (GetGameTimeMilliseconds() / 1000) + 23

    EVENT_MANAGER:RegisterForUpdate(CitizenSE.name .."ExecuteBanishTimer", 1000, ExeBanishTimer)
end


--Boss HP tracker
---CitizenSE.name .."AnsuulHp", 200
local function AnsuulHealth()
    if DoesUnitExist('boss1') then
        if GetUnitName('boss1') == "Ansuul the Tormentor" then
            local current, max, _= GetUnitPower('boss1', POWERTYPE_HEALTH)
            local hp = (current/max)*100
            local hpLeft = 0

            if hp >= 91 then
                hpLeft = hp-91
                if hpLeft<=5 and hpLeft>0 then
                    CitizenNotifier.SetBanner("|cb042ffBanish in|r: ".. string.format("%.1f", hpLeft) .."%")
                else
                    CitizenNotifier.RemoveBanner()
                end

            elseif hp<91 and hp>=71 then
                hpLeft = hp-71
                if hpLeft<=5 and hpLeft>0 then
                    CitizenNotifier.SetBanner("|cb042ffBanish in|r: ".. string.format("%.1f", hpLeft) .."%")
                else
                    CitizenNotifier.RemoveBanner()
                end

            elseif hp<71 and hp>=51 then
                hpLeft = hp-51
                if hpLeft<=5 and hpLeft>0 then
                    CitizenNotifier.SetBanner("|cb042ffBanish in|r: ".. string.format("%.1f", hpLeft) .."%")
                else
                    CitizenNotifier.RemoveBanner()
                end

            elseif hp<51 and hp>=31 then
                hpLeft = hp-31
                if hpLeft<=5 and hpLeft>0 then
                    CitizenNotifier.SetBanner("|cb042ffBanish in|r: ".. string.format("%.1f", hpLeft) .."%")
                else
                    CitizenNotifier.RemoveBanner()
                end

            elseif hp<31 and hp>22 then
                CitizenNotifier.RemoveBanner()

            elseif hp <= 22 then
                EVENT_MANAGER:RegisterForEvent(CitizenSE.name .."ExecuteBanish", EVENT_COMBAT_EVENT, ExeBanish)--FILTERS
                    EVENT_MANAGER:AddFilterForEvent(CitizenSE.name .."ExecuteBanish", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_BEGIN)
                    EVENT_MANAGER:AddFilterForEvent(CitizenSE.name .."ExecuteBanish", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 185117)
                --
                EVENT_MANAGER:UnregisterForUpdate(CitizenSE.name .."AnsuulHp")
            end
        end
    end
end

--Archers true shot
local function TrueshotTracker(_, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _)
    CitizenNotifier.Alert("|cfa9c1bTrueShot|r", 1500, SOUNDS.DUEL_START)
end

--Is player in combat with correct target
---CitizenAddon.name .."InCombatInSE", EVENT_PLAYER_COMBAT_STATE
function CitizenSE.CombatState(_, inCombat)
    if inCombat then
        if DoesUnitExist('boss1') then
            if GetUnitName('boss1') == "Exarchanic Yaseyla" then
                if CitizenAddon.SE.yaseyla.archerTrueShot then
                    EVENT_MANAGER:RegisterForEvent(CitizenSE.name .."TrueShot", EVENT_COMBAT_EVENT, TrueshotTracker)--FILTERS
                        EVENT_MANAGER:AddFilterForEvent(CitizenSE.name .."TrueShot", EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT, ACTION_RESULT_BEGIN)
                        EVENT_MANAGER:AddFilterForEvent(CitizenSE.name .."TrueShot", EVENT_COMBAT_EVENT, REGISTER_FILTER_ABILITY_ID, 184802)
                    --
                end
            elseif GetUnitName('boss1') == "Ansuul the Tormentor" then
                if CitizenAddon.SE.ansuul.banishTracker then
                    EVENT_MANAGER:RegisterForUpdate(CitizenSE.name .."AnsuulHp", 200, AnsuulHealth) --90% 70% 50% 30% > 20s
                end
            end
        end
    else
        Unregistor()
    end
end